﻿package {
	import flash.events.*;
	import flash.media.*;
	import flash.geom.Point;
	import flash.utils.*;
	import flash.display.*;
	import flash.filters.*;
	import flash.net.*;
	import flash.text.*;
	import RotPoint;
	import MoveController;
	public class LineTrace extends Sprite {
		private var controller:MoveController;
		private var now = 0;
		private var d = 1; // 変化量
		var mcList:Array = new Array();
		
		public function LineTrace() {
			stage.scaleMode=StageScaleMode.EXACT_FIT;
			stage.align=StageAlign.TOP_LEFT;
			
			controller = new MoveController();
			controller.partition = 50; // 移動点の間の分割量
			
			// 移動する点を設定
			controller.addPoint(-100,200, 60); // x,y,rotation
			controller.addPoint(200, 300, 0);
			controller.addPoint(440, 300, 0);
			controller.addPoint(740, 200, -60);
			// trace(controller.total+"分割");
			
			for(var i:int = 0; i < 100; i++){
				var mc:TestMc = new TestMc;
				this.addChild(mc);
				mc.pos = 0; // 初期位置
				controller.moveMC(mc, mc.pos);
				mcList.push(mc);
			}
			
			this.addEventListener(Event.ENTER_FRAME, reload); // 毎フレーム実行
			buttonL.addEventListener(MouseEvent.CLICK, function(){ d-=5 });
			buttonR.addEventListener(MouseEvent.CLICK, function(){ d+=5 });
		}
		
		private function reload(e:Event):void{
			now+=d;
			d*=0.9;
			for(var i:int = 0; i < mcList.length; i++){
				var mc:MovieClip = mcList[i];
				mc.pos = now-i*25; // 25間隔
				if(0 <= mc.pos && mc.pos <= controller.total)
				controller.moveMC(mc, mc.pos); // 無茶な位置を指定しても無視されるのでok
			}
		}
				
	}
}